##Exercicio de Crescimento Logistico##- Marina Xavier da Silva

##EX.01
##Funao Analitica
cresc.log=function(N0=10, r=0.05, K=80, tseq=1:100)
{
   resulta=K/(1+((K-N0)/N0)*exp(-r*tseq))
   return(resulta)
}
#Nt=K/(1+((K-N0)/N0)*exp(-r*tseq))
##Funao numerica
X11()
clogistico<-function(tempo, y, parms)
{
   n<-y[1]
   r<-parms[1]
   K<-parms[2]
   dN.dt<-r* n* (1- n/K)
   return(list(c(dN.dt)))
}

#parametros da funao

parametros=c(r=1.5,K=80)
N0= 10
st=seq(0.1,10, by=0.2)
numerica<-ode(y=N0, times=st, clogistico, parms=parametros)
numerica
plot(numerica[,1], numerica[,2], main="Comparando a analtica com a numerica", type="l", xlab="Tempo", ylab="N", col="red" )
legend("topleft", "N0=10;r=1.5; K=80", bty="n")

##Jogando a analitica em cima
ana=cresc.log(N0=10, r=1.5, K=80, tseq=st)
ana
lines(st,ana,col="blue")
legend("bottomright", c("numerica", "analitica"), pch=c(19,17), col=c("red", "blue"))

##mais simulaoes
parametros=c(r=1.5,K=60)
N0= 10
st=seq(0.1,10, by=0.2)
numerica2<-ode(y=N0, times=st, clogistico, parms=parametros)
lines(numerica2[,1], numerica2[,2], col="red")
#locator()
legend(5.87, 66.18,"N0=10;r=1.5;K=60", bty="n")
ana2=cresc.log(N0=10, r=1.5, K=60, tseq=st)
lines(st,ana2,col="blue")

##mais simulaao
parametros=c(r=1.5,K=50)
N0= 20
st=seq(0.1,10, by=0.2)
numerica3<-ode(y=N0, times=st, clogistico, parms=parametros)
lines(numerica3[,1], numerica3[,2], col="red")
ana3=cresc.log(N0=20, r=1.5, K=50, tseq=st)
lines(st,ana3,col="blue")
#locator()
legend(5.6,55.14,"N0=20;r=1.5;K=50", bty="n")

##mais simulaao
parametros=c(r=2.3,K=30)
N0= 10
st=seq(0.1,10, by=0.2)
numerica4<-ode(y=N0, times=st, clogistico, parms=parametros)
lines(numerica4[,1], numerica4[,2], col="red")
ana4=cresc.log(N0=20, r=1.5, K=30, tseq=st)
lines(st,ana4,col="blue")
#locator(1)
legend(6.08,33.91,"N0=10;r=2.3;K=30", bty="n")

##com a construao das simulaoes acima, eh possivel verificar que hah uma 
#aproximaao da soluao analitica com a numerica, mas existe uma diferena
## no tempo (eixo x). Como todas as simulaoes foram feitas com o mesmo tempo, 
##farei uma simulaao com um delta t bem pequeno.
X11()
parametros=c(r=1.5,K=80)
N0= 10
st=seq(0.001,10, by=0.1)##tempo bem pequeno!
numerica<-ode(y=N0, times=st, clogistico, parms=parametros)
numerica
plot(numerica[,1], numerica[,2], main="Comparando a analtica com a numerica", type="l", xlab="Tempo", ylab="N", col="red" )
legend("bottomleft", "N0=10;r=1.5; K=80;t=0.001", bty="n")

##Jogando a analitica em cima
anali=cresc.log(N0=10, r=1.5, K=80, tseq=st)
lines(st,anali,col="blue")
legend("bottomright", c("numerica", "analitica"), pch=c(19,17), col=c("red", "blue"))
##Agora, as duas curvas ajustam-se perfeitamente. Ou seja,
##a equaao logistica, como eq. diferencial que eh, trabalha com
##uma funao derivada em funo do tempo t. Este tempo t  um delta t
##que deve se aproximar o mais proximo de zero. Na soluo analitica, nos
##informamos este delta t, enquanto na soluao numerica a funao "ode" trabalha
##com um algoritmo por tras que ja calcula este delta t o mais proximo de zero,
##por isso, encontramos diferenas sutis entre elas. Na simulaao final, eu coloquei
##um intervalo de tempo bem pequeno na soluao analitica que se ajustou perfeitamente
##a criada pela funao ode.

##Ex.02
clogEst <- function(times,y, parms)
{
   n<-y[1]
   r<-rnorm(1,mean=parms[1],sd=sqrt(parms[2]))
   K<-parms[3]
   dN.dt<-r* n* (1- n/K)
   return(list(c(dN.dt))) 
} 
par(mfrow=c(2,2))
y0 = 1
prmt=c(rmedio=0.1, varr=0.5, K=20)
st=seq(0.1,200,by=0.01)
res.clogEst= ode(y=y0,times=st, func=clogEst,parms=prmt)
plot(res.clogEst[,1], res.clogEst[,2], type="l", col="red",lwd=2, xlab="tempo", ylab="tamanho da populao N")
abline(h=20)
legend("bottomright", "a=N0=1;r=0.1; var=0.5; K=20", bty="n")

y0 = 1
prmt=c(rmedio=0.1, varr=1.2, K=20)
st=seq(0.1,200,by=0.01)
res.clogEst= ode(y=y0,times=st, func=clogEst,parms=prmt)
plot(res.clogEst[,1], res.clogEst[,2], type="l", col="red",lwd=2, xlab="tempo", ylab="tamanho da populao N")
abline(h=20)
legend("bottomright", "b=N0=1;r=0.1; var=1.2; K=20", bty="n")

y0 = 10
prmt=c(rmedio=1.8, varr=0.5, K=20)
st=seq(0.1,200,by=0.01)
res.clogEst= ode(y=y0,times=st, func=clogEst,parms=prmt)
plot(res.clogEst[,1], res.clogEst[,2], type="l", col="red",lwd=2, xlab="tempo", ylab="tamanho da populao N")
abline(h=20)
legend("bottomright", "c=N0=1;r=1.8; var=0.5; K=20", bty="n")

y0 = 1
prmt=c(rmedio=1.8, varr=2.5, K=20)
st=seq(0.1,200,by=0.01)
res.clogEst= ode(y=y0,times=st, func=clogEst,parms=prmt)
plot(res.clogEst[,1], res.clogEst[,2], type="l", col="red",lwd=2, xlab="tempo", ylab="tamanho da populao N")
abline(h=20)
legend("bottomright", "d=N0=1;r=1.8; var=2.5; K=20", bty="n")

##A amplitude da variaao,  influenciada pelo r medio e sua variancia. Esta variancia
##representa a estocasticidade do meio ambiente, ou seja, todas as variaoes
## ao acaso das condioes ambientais e que influenciam os parametros populacionais.
## Biologicamente, penso que este dados podem exemplificar o que ocorre na natureza com
##especies r-estrategista de crescimento e reproduao rapida e, k-estrategistas, de crescimento
##lento. Estou com medo de seguir adiante com esta discussao, por estar completamente errada nesta 
##ideia!!! 


## simulando a extinao
par(mfrow=c(2,2))
y0 = 1
prmt=c(rmedio=1.5, varr=0.1, K=10)
st=seq(0.1,200,by=0.01)
res.clogEst= ode(y=y0,times=st, func=clogEst,parms=prmt)
plot(res.clogEst[,1], res.clogEst[,2], type="l", col="red",lwd=2, xlab="tempo", ylab="tamanho da populao N")
abline(h=10)
legend("bottomright", "N0=1;r=1.5; var=0.1; K=10", bty="n")

y0 = 1
prmt=c(rmedio=1.5, varr=1.1, K=10)
st=seq(0.1,200,by=0.01)
res.clogEst= ode(y=y0,times=st, func=clogEst,parms=prmt)
plot(res.clogEst[,1], res.clogEst[,2], type="l", col="red",lwd=2, xlab="tempo", ylab="tamanho da populao N")
abline(h=10)
legend("bottomright", "N0=1;r=1.8; var=1.1; K=10", bty="n")

y0 = 1
prmt=c(rmedio=1.5, varr=2.4, K=10)
st=seq(0.1,200,by=0.01)
res.clogEst= ode(y=y0,times=st, func=clogEst,parms=prmt)
plot(res.clogEst[,1], res.clogEst[,2], type="l", col="red",lwd=2, xlab="tempo", ylab="tamanho da populao N")
abline(h=10)
legend("bottomright", "N0=1;r=1.5; var=2.4; K=10", bty="n")

y0 = 1
prmt=c(rmedio=1.5, varr=10, K=10)
st=seq(0.1,200,by=0.01)
res.clogEst= ode(y=y0,times=st, func=clogEst,parms=prmt)
plot(res.clogEst[,1], res.clogEst[,2], type="l", col="red",lwd=2, xlab="tempo", ylab="tamanho da populao N")
abline(h=20)
legend("bottomright", "N0=1;r=1.5; var=10; K=10", bty="n")
##nestes casos podemos observar que quanto maior a variaao, maiores e
##mais rapidas serao as chances de extinao mesmo com um "r" positivo.

##Ex.03
require("PBSddesolve")
clogDelay <- function(t,N,parms) 
{
   if (t < parms[3])
      lag <- parms[4]
   else
      lag <- pastvalue(t - parms[3])
   
   n<-lag
   r<-parms[1]
   K<-parms[2]
   dN.dt<-r* n* (1- n/K)
   return(list(c(dN.dt)))
}

## O comportamento desta eq. diferencial depende do retardo e do tempo de resposta
##Sendo assim calculei um r para cada situaao proposta:
##r/r*retardo
##situao 1 - r<0.36
r1=0.36/0.5

par(mfrow=c(1,3))
N0= 10
parametros=c(r1,K=100, retardo=0.5, initial=N0)
pop <- dde(y=N0,times=seq(0,100,0.1),func=clogDelay ,parms=parametros)
plot(pop$t, pop$y1, type="l", col="red", xlab="tempo", ylab="Numero de indivduos", main="Crescimento Logistico\n com retardo")
abline(h=100)
legend("bottomright", "retardo<0.36", bty="n")

##retardos curtos, geram oscilaoes quase imperceptiveis. Neste caso, o comportamento
##da curva com o retardo eh quase igual a do modelo sem retardo.

##situao 2 - entre 0.36 e 1.5
b=seq(0.37,1.5, by=0.01)
median(b)##para achar um valor que represente os valores intermediarios
r2=0.9/0.5

parametros=c(r2,K=100, retardo=0.5, initial=N0)
pop2 <- dde(y=N0,times=seq(0,100,0.1),func=clogDelay ,parms=parametros)
plot(pop2$t, pop2$y1, type="l", col="red", xlab="tempo", ylab="Numero de indivduos", main="Crescimento Logistico\n com retardo")
abline(h=100)
legend("bottomright", "0.36<retardo<1.5", bty="n")
##Neste caso, com r*retardo intermediario, a populaao oscila em torno de K no comeo, mas satura em K.

## Situaao 3 - r>1.5
r3=1.6/0.5
parametros=c(r3,K=100, retardo=0.5, initial=N0)
pop3 <- dde(y=N0,times=seq(0,100,1),func=clogDelay ,parms=parametros)
plot(pop3$t, pop3$y1, type="l", col="red", xlab="tempo", ylab="Numero de indivduos", main="Crescimento Logistico\n com retardo")
abline(h=100)
legend("bottomright", "retardo>1.5", bty="n")

##O ultimo grafico mostra que a populaao entra em um ciclo estavel
##em torno de K, sem nunca estabilizar.

##O r*retardo demonstra que o crescimento observado daquele momento eh
##decorrente da populaao em um momento anterior.

